/* -*-  Mode:C; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*
 * Copyright (c) 1999, 2000 Massachusetts Institute of Technology.
 *
 * This software is being provided by the copyright holders under the GNU
 * General Public License, either version 2 or, at your discretion, any later
 * version. (See the file `LICENSE' in the Linux source distribution.)
 *
 * This software is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. The entire risk as
 * to the quality and performance of the program is with you. See the GNU
 * General Public License for more details.
 *
 * The name and trademarks of copyright holders may NOT be used in 
 * advertising or publicity pertaining to the software without specific, 
 * written prior permission. Title to copyright in this software and any 
 * associated documentation will at all times remain with copyright 
 * holders. See the file CMAUTHORS which should have accompanied this software 
 * for a list of all copyright holders. 
 * 
 * Particular files in this distribution may be derived from previously
 * copyrighted software. This copyright applies only to those changes made by
 * the copyright holders listed in the CMAUTHORS file.
 */
/*
 * An implementation of the Congestion Manager (CM) for Linux.
 * CM round-robin scheduler declarations.
 */
#include <net/cm.h>

#ifndef _CM_RRSCHED_H
#define _CM_RRSCHED_H

extern void cmrrs_init(cm_sched_t *cms);
extern cm_flow_t *cmrrs_sched(cm_sched_t *cms);
extern void cmrrs_schedule(cm_sched_t *cms);
extern double cmrrs_query_share(cm_sched_t *cms, cm_flow_t *flow);
extern void cmrrs_delete_flow(cm_sched_t *cms, cm_flow_t *flow);
extern void cmrrs_notify(cm_sched_t *cms, cm_flow_t *flow, int nsent);

#endif
